#include <string.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc,char **argv)
{
	int 	animations=0,
		frames=0;
	FILE 	*fd0;
	char	str[100];
	bool	bit=0;
	if (--argc<1)
	{
		printf("Usage %s texturemodel.ase [D|S]] file.ase file.ase [D|S] file.ase file.ase > output.mdh.\n",argv[0]);
		exit(1);
	} else {
	int i;
	for (i=2;i<=argc;i++)
		if ( (!strcmp("S",argv[i])) || (!strcmp("D",argv[i]))  ) animations++;	
		else frames++; 
	fd0=fopen(argv[1],"r");
	if (!fd0){
		fprintf(stderr,"Cannot open texture model\n");
		exit(1); }
	if (!frames||!animations) { fprintf(stderr,"Bad options\n"); exit(1); }
	fprintf(stderr,"Default speed = 200\n");
	fprintf(stderr,"Found %d frames with %d animations\n",frames,animations);
	printf(	"# ase2mdh - conversor by pancake\n"
		"# \n");
	printf( "&NUM_FRAMES %d\n"
		"&NUM_ANIMATIONS %d\n"
		"&SPEED 200\n",
		frames,animations);
	while(!feof(fd0))
			{
			fscanf(fd0,"%s",str);
			if (!strcmp("*BITMAP",str))
					{
					fgets(str,100,fd0);
					printf("&TEXTURE %s",str);
			} else
			if (!strcmp("*MESH_NUMVERTEX",str))
					{
					fscanf(fd0,"%s",str);
					printf("&VERTEX %s\n",str);
			} else
			if (!strcmp("*MESH_NUMFACES",str))
					{
					fscanf(fd0,"%s",str);
					printf("&FACES %s\n",str);
			} else
			if ( (!strcmp("A:",str)) || (!strcmp("B:",str)))
					{
					fscanf(fd0,"%s",str);
					printf("%s ",str);
			} else
			if (!strcmp("C:",str))
					{
					fscanf(fd0,"%s",str);
					printf("%s\n",str);
			} else
			if (!strcmp("*MESH_NUMTVERTEX",str))
					{
					fscanf(fd0,"%s",str);
					printf("\n&MAP_PARTS %s\n",str);
			} else
			if (!strcmp("*MESH_TVERT",str))
					{
					fscanf(fd0,"%s",str);
					fscanf(fd0,"%s",str);
					printf("%s\t",str);
					fscanf(fd0,"%s",str);
					printf("%s\n",str);
					fgets(str,100,fd0);
			} else
			if (!strcmp("*MESH_NUMTVFACES",str))
					{
					fscanf(fd0,"%s",str);
					printf("\n&MAP_FACES %s\n",str);
			} else
			if (!strcmp("*MESH_TFACE",str))
					{
					int j;
					fscanf(fd0,"%s",str);
					for(j=0;j<3;j++){
						fscanf(fd0,"%s",str);
						printf ("%s ",str);
						}
					printf("\n");
					}
			}
	fclose(fd0);
	for (i=2;i<=argc;i++)
	{
	if ( (!strcmp("S",argv[i])) || (!strcmp("D",argv[i]))  ) 
		{
		printf("\n*%s\n",argv[i]); // canvi d'animacio.
		bit=1;
		continue;
		}
	else 	{
		if (!bit) printf("\n.\n"); // canvi de frame.
		bit=0;
		fprintf(stderr,"+ Loading %s\n", argv[i]);
		}

	fd0=fopen(argv[i],"r");
	if (!fd0){
		printf("Cannot open file: %s",argv[i]);
		exit(1);
		}

	while(!feof(fd0))
		{
		fscanf(fd0,"%s",str);
		if (!strcmp(str,"*MESH_VERTEX")){
			fscanf(fd0,"%s",str);
			fscanf(fd0,"%s",str); printf ("%s  ",str);
			fscanf(fd0,"%s",str); printf ("%s  ",str);
			fscanf(fd0,"%s",str); printf ("%s\n",str);
			}
		}
	}
	}
	return 0;
}
